"""
    ChannelEngine Channel API

    ChannelEngine API for channels  # noqa: E501

    The version of the OpenAPI document: 2.9.9
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from channelengine_channel_api_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from channelengine_channel_api_client.model.channel_return_line_request import ChannelReturnLineRequest
    from channelengine_channel_api_client.model.return_reason import ReturnReason
    globals()['ChannelReturnLineRequest'] = ChannelReturnLineRequest
    globals()['ReturnReason'] = ReturnReason


class ChannelReturnRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('lines',): {
            'min_items': 1,
        },
        ('customer_comment',): {
            'max_length': 4001,
            'min_length': 0,
        },
        ('merchant_comment',): {
            'max_length': 4001,
            'min_length': 0,
        },
        ('refund_incl_vat',): {
            'inclusive_minimum': 0,
        },
        ('refund_excl_vat',): {
            'inclusive_minimum': 0,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'channel_reference': (str,),  # noqa: E501
            'lines': ([ChannelReturnLineRequest],),  # noqa: E501
            'channel_order_no': (str, none_type,),  # noqa: E501
            'merchant_order_no': (str, none_type,),  # noqa: E501
            'key_is_merchant_order_no': (bool,),  # noqa: E501
            'key_is_merchant_product_no': (bool,),  # noqa: E501
            'id': (int,),  # noqa: E501
            'reason': (ReturnReason,),  # noqa: E501
            'customer_comment': (str, none_type,),  # noqa: E501
            'merchant_comment': (str, none_type,),  # noqa: E501
            'refund_incl_vat': (float,),  # noqa: E501
            'refund_excl_vat': (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'channel_reference': 'ChannelReference',  # noqa: E501
        'lines': 'Lines',  # noqa: E501
        'channel_order_no': 'ChannelOrderNo',  # noqa: E501
        'merchant_order_no': 'MerchantOrderNo',  # noqa: E501
        'key_is_merchant_order_no': 'KeyIsMerchantOrderNo',  # noqa: E501
        'key_is_merchant_product_no': 'KeyIsMerchantProductNo',  # noqa: E501
        'id': 'Id',  # noqa: E501
        'reason': 'Reason',  # noqa: E501
        'customer_comment': 'CustomerComment',  # noqa: E501
        'merchant_comment': 'MerchantComment',  # noqa: E501
        'refund_incl_vat': 'RefundInclVat',  # noqa: E501
        'refund_excl_vat': 'RefundExclVat',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, channel_reference, lines, *args, **kwargs):  # noqa: E501
        """ChannelReturnRequest - a model defined in OpenAPI

        Args:
            channel_reference (str): The unique return reference used by the Channel.
            lines ([ChannelReturnLineRequest]):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            channel_order_no (str, none_type): The unique order reference used by the Channel.. [optional]  # noqa: E501
            merchant_order_no (str, none_type): The unique order reference used by the Merchant (sku).. [optional]  # noqa: E501
            key_is_merchant_order_no (bool): Optional. Is the MON used as key for the order (default value is false).. [optional]  # noqa: E501
            key_is_merchant_product_no (bool): Optional. Is the MPN used as key for the product (default value is false).. [optional]  # noqa: E501
            id (int): The unique return reference used by ChannelEngine.. [optional]  # noqa: E501
            reason (ReturnReason): [optional]  # noqa: E501
            customer_comment (str, none_type): Optional. Comment of customer on the (reason of) the return.. [optional]  # noqa: E501
            merchant_comment (str, none_type): Optional. Comment of merchant on the return.. [optional]  # noqa: E501
            refund_incl_vat (float): Refund amount incl. VAT.. [optional]  # noqa: E501
            refund_excl_vat (float): Refund amount excl. VAT.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.channel_reference = channel_reference
        self.lines = lines
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
